//+------------------------------------------------------------------+
//|                                         Lesson 2. Properties.mqh |
//|                                                      Peter Konow |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
//----------------------------------------------
//LESSON 2. WINDOW, ELEMENT, AND OBJECT PROPERTIES. SWITCH, BLOCKS OPERATORS.
//----------------------------------------------

//---------------------------------
//CONTENTS:
//---------------------------------
1.   CLASSIFICATION OF PROPERTIES.

2.   WINDOW PROPERTIES.

3.   ELEMENT PROPERTIES.

4.   OBJECT PROPERTIES.

5.   SIMPLE OPERATORS.

//---------------------------------


1.  PROPERTIES ARE DIVIDED INTO GROUPS BASED ON SEVERAL CRITERIA:
//============================================================================================================================
   a) INDIVIDUAL PROPERTIES - SET FOR EACH ELEMENT SEPARATELY INSIDE THE LINE OF ITS DECLARATION OR BEYOND ITS GROUP:
   
//---------------------------------------------
//CANVAS ON WHICH ELEMENTS WILL BE DRAWN.
//---------------------------------------------
GROUP, A,  

__, REC, "R1", W, 600, _, H, 300, _, N_FRAME, 1, _, N_COLOR, (int)C'255,255,255', <--  CHAIN OF INDIVIDUAL PROPERTIES INSIDE ELEMENT DECLARATION LINE.
                                                                             (ENUMERATED VIA _, MANDATORY EXCEPT FOR THE FIRST FROM ELEMENT NAME).

END_GROUP,
//-----------------------------------
   
//============================================================================================================================
   b) COMMON PROPERTIES OF SIMILAR ELEMENTS WITHIN A GROUP - SET TO ALL ELEMENTS OF THE SAME TYPE IN THE GROUP.
   
//-------------------------------------------------------
 GROUP, "Main tabs",

__, H_TAB, "Color settings", ON,   H_TAB, "Indicators",  H_TAB, "Hotkeys",  

END_GROUP,
//----------------------------
//POSITION OF THE GROUP ON THE WINDOW CANVAS.
//----------------------------
i, AT, _X2X, "MF", 5, _Y2Y, "MF", 5,
//----------------------------
   
i, H_TABS,      <----  START SETTING PROPERTIES TO MULTIPLE ELEMENTS OF THE SAME TYPE 
                                         (ELEMENT NAME IN PLURAL).
                                         
//-----------------------------------------------------
 AH_COLOR, (int)C'255,255,255', // ACTIVATED AND USER-SELECTED STATE COLOR
//----------------------------------------------------- 
 A_COLOR,  (int)C'255,255,255', // ACTIVE STATE COLOR
//----------------------------------------------------- 
 N_COLOR,  (int)C'250,250,250', //NEUTRAL STATE COLOR
//----------------------------------------------------- 
 P_COLOR,  (int)C'236,244,252', //POINTED STATE COLOR
//-----------------------------------------------------

//---------------------------- 
 N_FRAME,   1,  //FRAME OF THE NEUTRAL STATE
                                                      <----     SETTING TABS PROPERTIES.
 A_FRAME,   1,  //FRAME OF THE ACTIVE STATE   
 
 NP_FRAME,  1,  //FRAME OF THE NEUTRAL POINTED STATE  
 //----------------------------
 
 //---------------------------- 
 NPG_LINES, 20, 
 NPG_STEP,  1,                                          
 NG_LINES,  20, 
 NG_STEP,   1, 
//---------------------------- 
 FONT_SIZE, 12,                                        (ORDER OF ENUMERATION IS INSIGNIFICANT).
//----------------------------
 END,                                         <----     FINISH MASS PROPERTY SETTING.     
//----------------------------
//============================================================================================================================

    c) PROPERTIES WITH A PREFIX THAT INDICATES A STATE. THERE ARE 8 BASIC ELEMENT STATES:
        
//--------------------------------------------------------------------------------------------------------------------   
        1) NEUTRAL STATE                                                        -  N_.
//--------------------------------------------------------------------------------------------------------------------     
        2) NEUTRAL FOCUS STATE - ELEMENT SELECTED BUT NOT ACTIVATED             -  NH_.
//--------------------------------------------------------------------------------------------------------------------           
        3) ACTIVE STATE                                                         -  A_.
//--------------------------------------------------------------------------------------------------------------------           
        4) ACTIVE FOCUS STATE - ELEMENT ACTIVATED AND USER-SELECTED             -  AH_.
//--------------------------------------------------------------------------------------------------------------------           
        5) BLOCKED NEUTRAL STATE                                                -  NB_.
//--------------------------------------------------------------------------------------------------------------------          
        6) BLOCKED ACTIVE STATE                                                 -  AB_.
//--------------------------------------------------------------------------------------------------------------------           
        7) NEUTRAL UNDER CURSOR                                                 -  NP_.
//--------------------------------------------------------------------------------------------------------------------           
        8) ACTIVE UNDER CURSOR                                                  -  AP_.
//--------------------------------------------------------------------------------------------------------------------   


        
    //-----------------------------------------------    
    LIST OF PROPERTIES DEFINED BY ELEMENT STATE:
    //-----------------------------------------------
     
       1) COLOR PROPERTIES: ELEMENT BASES AND TEXTS. 
       
          N_COLOR, A_COLOR, NH_COLOR, AH_COLOR, NB_COLOR, AB_COLOR, NP_COLOR, AP_COLOR.
          //-----------------------------------------------------------------------------------------------
          
          ELEMENT FRAME COLORS:
       
          N_FRAME_COLOR, A_FRAME_COLOR, NH_FRAME_COLOR, AH_FRAME_COLOR, NP_FRAME_COLOR, AP_FRAME_COLOR.
       
//--------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------------------
          (TO SET THESE PROPERTIES TO ELEMENT TEXTS OR OTHER COMPONENTS, THEIR NAMES ARE WRITTEN: text, label, canvas, bar)
          //-----------------------------------------------------------------------------------------------
          
           _, text, A_COLOR, (int)C'255,255,255', <-- COLOR WILL BE SET TO TEXT, NOT BASE.
          
//--------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------------------
       2) SOUND PROPERTIES - A_SOUND, N_SOUND   <--  SOUND ON PRESS/RELEASE OF ELEMENT.  
       //-----------------------------------------------------------------------------------------------  
       
          _, A_SOUND, "::Sounds\\Windows Ding.wav", _, N_SOUND, "::Sounds\\Windows Default.wav"

//--------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------------------
       3) PROPERTIES OF TEXT AND LABEL SHADOW LENGTH AND MOVEMENT - A_SHADOW, P_SHADOW, A_MOVE, P_MOVE. 
       //-----------------------------------------------------------------------------------------------
       
              _, bar, NH_COLOR, (int)C'255,255,255', (COLOR OF SLIDER BAR (OR D_BAR OR P_BAR) IN NEUTRAL FOCUS STATE).
              
              //-----------------------------------------------------
               
              _, label, A_SHADOW, 3,  (IN ACTIVE STATE, ICON SHADOW IS MOVED BY 3 PIXELS).
              
              //-----------------------------------------------------
              
              _, label, P_MOVE, 2,  (MOVES ICON WHEN CURSOR IS HOVERED BY 2 PIXELS DOWN AND RIGHT).
              
//--------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------------------       
       4)TEXT PROPERTIES:
       
          //-----------------------------------------------------------------------------------------------
          1) TEXT_FONT:         _, TEXT_FONT, "Microsoft JhengHei Light",
          //-----------------------------------------------------------------------------------------------
          2) TEXT_STYLE:        _, TEXT_STYLE, (int)FW_NORMAL,
          //-----------------------------------------------------------------------------------------------
          3) FONT_SIZE:         _, FONT_SIZE,  25,
          //----------------------------------------------------------------------------------------------- 
          4) TEXT_ANGLE:        _, TEXT_ANGLE, 450, (45 DEGREES).     
          //-----------------------------------------------------------------------------------------------
          
          
    //--------------------------------------------------------------------------------------------    
    d) FLAG PROPERTIES     - DIFFERENT ELEMENTS OR WINDOWS HAVE DIFFERENT FLAG PROPERTIES:
    //--------------------------------------------------------------------------------------------
       ELEMENTS:
       //-----------------
       
       1) FIC (FIXED_IF_CLICKED), FIXED_IF_DOUBLE_CLICKED  - ALL SORTS OF BUTTONS. 
       //-------------------------------------------------------------------------------------------------------------------- 
        
       2) IS_APPEARANCE_CONTROLLER        (LIST OF ELEMENTS ENDING WITH END) - TABS AND BUTTONS. 
       
                                          ("Button 1",  IS_APPEARANCE_CONTROLLER, "Button 2","Button 3","Button 4",...END,)         
            
                                           //(*the appearance controller must be above controlled elements in the group order)
                       
       //-------------------------------------------------------------------------------------------------------------------- 
       3) IS_HIDDEN                      - FLAG HIDING ANY ELEMENTS OR GROUPS (DEPENDS ON WHERE IT IS PLACED). DEPENDS ON 1 OR 0. 
       
                                          (_,IS_HIDDEN, 1,)
                                          
       //-------------------------------------------------------------------------------------------------------------------- 
       
       4) POINTED                        - FLAG SETTING ELEMENTS REACTION TO CURSOR. DEPENDS ON 1 OR 0. 
       
                                          (_,POINTED, 1,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       5) READ_ONLY                     - FLAG FOR INPUT FIELDS 
                                        
                                         (_,EDIT,"EDIT 1",READ_ONLY).
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       6) IS_TABLE                      - FLAG FOR TABLE. SET TO GROUP OF ELEMENTS THAT NEED TO BE PRESENTED AS A TABLE. 
                                          
                                          (GROUP, A, IS_TABLE,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       7) IS_MOVABLE                    - SETS ELEMENT MOVABILITY ON WINDOW CANVAS.
                                 
                                          (_,IS_MOVABLE,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       8) IS_STRETCHABLE                - SETS ELEMENT STRETCHABILITY ON CANVAS.
                                          
                                          (_,IS_STRETCHABLE,)
                                          
       //--------------------------------------------------------------------------------------------------------------------
        
       9) SHOW_NAMETIP                  - SETS POP-UP HINT WITH ELEMENT NAME. 
       
                                          (_,SHOW_NAMETIP,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       10) SHOW_WIDGET                  - SETS SLIDER TABLET, MOVING BEHIND HANDLE. 
       
                                          (_,SHOW_WIDGET,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       11) SCROLLBAR_ON_LEFT            - SETS SCROLL BAR ON LEFT SIDE.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       12) ALL_STATES_SAME_COLOR        - SETS SAME COLOR FOR ALL ELEMENT STATES. 
       
                                          (i, BUTTONS, W,100,  H,30, ALL_STATES_SAME_COLOR, END,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       13) CWIP (CLOSE WINDOW IF PRESSED) - SETS DIALOG WINDOW BUTTONS. CLOSES WINDOW WHEN BUTTON IS PRESSED.
       
       //--------------------------------------------------------------------------------------------------------------------
        
       14) A2G (ADAPT_2_GRADIENT)       - ADAPTS ELEMENT BASE COLOR TO CANVAS GRADIENT. 
       
                                          (_,BUTTON, A2G,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       15) H_GRADIENT                   - CHANGES GRADIENT LAYOUT TO VERTICAL.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       16) TEXT_ALIGN                   - SETS TEXT FIELD LAYOUT. TWO FLAGS TEXT_ALIGN_RIGHT AND TEXT_ALIGN_CENTER.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       17) SHOWS_TIP                    - SETS POP-UP TIP WITH SPECIFIED CONTENT WHEN POINTED. 
       
                                          (_,SHOWS_TIP,"PLEASE READ THIS MANUAL",)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       18) FRAME_TYPE                   - SETS OBJECT FRAME TYPE 
       
                                          (CAN SPECIFY 1,2,3 OR ALL 4 SIDES).
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       19) A_TEXT                       - SETS ALTERNATIVE TEXT DISPLAYED ON BUTTON PRESS.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       20) SWITCH_ALL                   - SETS ALL ELEMENTS SWITCHES IN GROUP (LIKE RADIO BUTTONS). 
       
                                          (i, BUTTONS, W,100,  H,30, SWITCH_ALL, END,)
       
       //--------------------------------------------------------------------------------------------------------------------
        
       21) OPENS_WINDOW                 - SETS WINDOW OPENING ON ELEMENT PRESS.  
       
                                         (_,OPENS_WINDOW,"WINDOW NAME")
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       22) KC_TEXT                      - SETS TEXT IN RIGHT SIDE OF MENU WINDOW ITEM.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       23) ROOT                         - MAIN COLLAPSER, CREATES TREE-LIKE STRUCTURE OF ELEMENT LIST.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       24) ON                           - SETS ELEMENT INITIAL ON STATE.  
       
                                          (_,BUTTON, ON,)
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       25) SET_TAB_CLOSER               - SETS CLOSING CROSS FOR TAB. (WORKS ONLY IN DYNAMIC LIST).
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       26) C_FUNCTION                   - SETS FUNCTION CALL ON ELEMENT CLICK.
       
       //--------------------------------------------------------------------------------------------------------------------
        
       27) DC_FUNCTION                  - SETS FUNCTION CALL ON DOUBLE-CLICK ON ELEMENT.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       28) DnD_FUNCTION                 - SETS FUNCTION CALL ON Drag_n_Drop EVENT.
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       29) SWITCH                       - SETS ENUMERATION OF SWITCHING ELEMENTS ENDING WITH END. 
       
                                          (SWITCH, "Button 1", "Button 2", "Button 3",... END) 
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       30) BLOCKS                       - SETS ENUMERATION OF BLOCKED ELEMENTS ENDING WITH END.   
       
                                          ("Checkbox 1", BLOCKS, "Button 1", "Button 2", "Button 3",... END) 
       
       //-------------------------------------------------------------------------------------------------------------------- 
       
       
       
       
       //--------------------------------------------------------------------------------------------------------------------
        TABLE FLAGS:
      //-------------------------------------------------------------------------------------------------------------------- 
      1) IS_ZEBRA_STYLE                - SETS ZEBRA STYLE.
      //-------------------------------------------------------------------------------------------------------------------- 
      2) ADJUSTABLE_COLUMNS            - SETS TABLE COLUMN STRETCH.
      //-------------------------------------------------------------------------------------------------------------------- 
      3) IS_INTERACTIVE                - SETS ROWS TO REACT TO THE CURSOR.
      //-------------------------------------------------------------------------------------------------------------------- 
      4) HIDE_SHOW_COLOMN              - SETS THE ABILITY TO HIDE/SHOW TABLE COLUMNS.
      //-------------------------------------------------------------------------------------------------------------------- 
      5) ROTATE_COLOMNS                - SETS THE ABILITY TO SWITCH COLUMNS.
      //-------------------------------------------------------------------------------------------------------------------- 
      6) IS_DYNAMIC                    - MAKES THE TABLE DYNAMIC.
      //-------------------------------------------------------------------------------------------------------------------- 
      7) ZB_COLOR                      - SETS ZEBRA STYLE COLOR 1.
      //-------------------------------------------------------------------------------------------------------------------- 
      8) ZD_COLOR                      - SETS ZEBRA STYLE COLOR 2.
      //-------------------------------------------------------------------------------------------------------------------- 
      9) PAINT_VALUES                  - PAINTS VALUES IN CELLS.
      //-------------------------------------------------------------------------------------------------------------------- 
      10) ROW                          - OPENS ENUMERATION FOR SETTING PROPERTIES OF THE SELECTED TABLE ROW. ENDS WITH END.
      //-------------------------------------------------------------------------------------------------------------------- 
      11) COLUMN                       - OPENS ENUMERATION FOR SETTING PROPERTIES OF THE SELECTED TABLE COLUMN. ENDS WITH END.
      //-------------------------------------------------------------------------------------------------------------------- 
      12) SELECTABLE_ROWS              - SETS SELECTABLE TABLE ROWS.
      //-------------------------------------------------------------------------------------------------------------------- 
      13) IS_SORTABLE                  - SETS ROW SORTING ABILITY.
      //-------------------------------------------------------------------------------------------------------------------- 
      
      
      
      
      
      
      //--------------------------------------------------------------------------------------------------------------------
      PARAMETER PROPERTIES:
      //--------------------------------------------------------------------------------------------------------------------
      
      1) PARAM_TYPE,                   - _DOUBLE, _INT, MENU, RANGE, <-- PARAMETER TYPES.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      2) V_CURRENT                     - SETS DEFAULT VALUE TO THE ELEMENT PARAMETER.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      3) V_MIN                         - SETS MINIMUM VALUE BOUNDARY (FOR SLIDERS AND INPUT FIELDS WITH BUTTONS).
      
      //--------------------------------------------------------------------------------------------------------------------
      
      4) V_MAX                         - SETS MAXIMUM VALUE BOUNDARY (FOR SLIDERS AND INPUT FIELDS WITH BUTTONS).
      
      //--------------------------------------------------------------------------------------------------------------------
      
      5) V_STEP                        - SETS VALUE STEP (FOR SLIDERS AND INPUT FIELDS WITH BUTTONS).
      
      //--------------------------------------------------------------------------------------------------------------------
      
      6) DIGITS                        - SETS NUMBER OF DIGITS AFTER THE DECIMAL POINT.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      7) __UNITS                       - SETS MEASUREMENT UNITS BEFORE THE VALUE.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      8) __UNITS                       - SETS MEASUREMENT UNITS AFTER THE VALUE.
      
      //--------------------------------------------------------------------------------------------------------------------
   
      WINDOW FLAGS:
      //--------------------------------------------------------------------------------------------------------------------
      
      1) ALWAYS_ON_TOP                 - WINDOW ALWAYS ON TOP.
      
      //-------------------------------------------------------------------------------------------------------------------- 
      
      2) NIM (NAME_IN_MIDDLE)          - CENTER WINDOW NAME.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      3) OOI (OPEN_ON_INIT)            - OPEN WINDOW ON PROGRAM INITIALIZATION.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      4) CLOSE_IF_OUT_OF_FOCUS         - CLOSE WINDOW IF CLICKED OUTSIDE OF IT.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      5) LOCKS_ALL_WINDOWS             - LOCKS ALL WINDOWS UNTIL THIS ONE IS CLOSED.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      6) ONLY_CLOSING                  - REMOVES WINDOW MINIMIZATION OPTION, LEAVING ONLY THE CLOSE BUTTON.
      
      //--------------------------------------------------------------------------------------------------------------------

      
      
      
      //--------------------------------------------------------------------------------------------------------------------
      COMMON WINDOW PROPERTIES:
      //--------------------------------------------------------------------------------------------------------------------
      
      1) MARGINS, 10,10                - SETS ADJUSTMENTS TO WINDOW SIZE, AUTOMATICALLY CALCULATED BASED ON CONTENT SIZE.
      
      //--------------------------------------------------------------------------------------------------------------------
      
      2) OPENING_SOUND                 - SETS SOUND PLAYED ON WINDOW OPENING.  
                         //EXAMPLE:

                                         NEW_WINDOW,  W_NAME, "Incorrect settings", 
                                       
                                         QUESTION_SIGN,
                                       
                                         NIM,           //NAME IN THE MIDDLE
                                       
                                         CAPTION, "Error", 
                                         
                                         W_ICON, "::Images\\16x16\\No (16x16)",  
                                       
                                         W_TYPE, DIALOG,  
                                       
                                         ONLY_CLOSING, 
                                       
                                         ALWAYS_ON_TOP, 
                                       
                                         OOI,          // OPEN_ON_INIT,
                                       
                                         LOCKS_WINDOWS, ALL_WINDOWS,  

                                         OPENING_SOUND,"::Sounds\\Windows Foreground.wav", 

                                           
      //--------------------------------------------------------------------------------------------------------------------
      
      3) LOCKS_WINDOWS                 - ENUMERATION OF WINDOW NAMES TO BE LOCKED UNTIL THIS WINDOW IS CLOSED. ENDS WITH END.
      
                                         "Window 1",LOCKS_WINDOWS, "Window 2", "Window 3", "Window 4", ...END
                                         
      //--------------------------------------------------------------------------------------------------------------------
      
      4) CAPTION                       - WINDOWS MUST HAVE DIFFERENT NAMES, BUT WINDOW TITLES CAN BE THE SAME (E.G., FOR STANDARD MESSAGE DIALOGS).
      
                                        (NEW_WINDOW,  W_NAME, "Allow changes", CAPTION, "User permission",) 
      
      //--------------------------------------------------------------------------------------------------------------------
      
      NEW_WINDOW, W_NAME,"KIB1 Directory", W_ICON,"::Images\\Help book 3d.bmp", W_TYPE, SETTINGS, OOI, MARGINS,17,17, ALWAYS_ON_TOP, NAME_IN_MIDDLE,

      NEW_WINDOW, W_NAME, "Risk Management Access", CAPTION, "Access Authorization", W_ICON, "::Images\\Key.bmp", W_TYPE, DIALOG, ONLY_CLOSING, ALWAYS_ON_TOP, OOI,


     