//+------------------------------------------------------------------+
//|                                        MAJOR KIB-code errors.mqh |
//+------------------------------------------------------------------+

//---------------------------------------------------------------------
// MAJOR ERRORS IN WRITING KIB CODE:
//---------------------------------------------------------------------

//---------------------------------------------------------------------

1. MISSING COMMAS BETWEEN WORDS AND VALUES.

   IT IS IMPORTANT TO REMEMBER: WE ARE INITIALIZING AN ARRAY.
   
   EVERYTHING WRITTEN IN KIB CODE IS INITIALIZATION.
   
   VIOLATION OF INITIALIZATION RULES (SUCH AS MISSING COMMAS) LEADS TO MAJOR ERRORS.

//---------------------------------------------------------------------

//---------------------------------------------------------------------

2. SKIPPING KEYWORDS LEADS TO MAJOR ERRORS IN GUI CONSTRUCTION:

NEW_WINDOW,

END_WINDOW,

GROUP, "Group name",

END_GROUP,

//---------------------------------------------------------------------

//---------------------------------------------------------------------

3. SKIPPING GROUP POSITIONING IN THE WINDOW SPECIFICATION. FOR EXAMPLE:

     i, AT, _X2X, "MF", 10, _Y2Y, "MF", 10,  (STANDARD POSITIONING)
     
     OR
     
     i, AT, LEFT_TOP, 1,1, (POSITIONING USING FLAGS)

    *SKIPPING POSITIONING LEADS TO GROUP ELEMENTS DISAPPEARING FROM THE WINDOW.

//---------------------------------------------------------------------

//---------------------------------------------------------------------

4. ELEMENT OR WINDOW NAMES WRITTEN WITHOUT QUOTATION MARKS LEAD TO COMPILER ERRORS.

//---------------------------------------------------------------------

//---------------------------------------------------------------------

5. DECLARING ELEMENTS OUTSIDE A GROUP.

     IF ELEMENTS ARE DECLARED OUTSIDE A GROUP, A MAJOR GUI CONSTRUCTION ERROR OCCURS.
     
     ALL ELEMENTS MUST BE DECLARED BETWEEN KEYWORDS GROUP, "Group name", END_GROUP,

//---------------------------------------------------------------------

//---------------------------------------------------------------------

6. DECLARING A GROUP OF ELEMENTS OUTSIDE A WINDOW.

     IF GROUPS OF ELEMENTS ARE DECLARED OUTSIDE A WINDOW, A MAJOR GUI CONSTRUCTION ERROR OCCURS.
     
     ALL GROUPS MUST BE DECLARED BETWEEN KEYWORDS NEW_WINDOW, "Window name", END_WINDOW,

//---------------------------------------------------------------------

//---------------------------------------------------------------------

7. INCORRECT PLACEMENT OF GROUP ELEMENT POSITIONING LINE.

   THE GROUP ELEMENT POSITIONING LINE MUST IMMEDIATELY FOLLOW THE END_GROUP KEYWORD,
   
   AND CANNOT BE PLACED ANYWHERE ELSE.

//---------------------------------------------------------------------

//---------------------------------------------------------------------

8. IDENTICAL NAMES OF ELEMENTS WITHIN THE SAME WINDOW LEAD TO INTERFACE CONSTRUCTION FAILURES.

//---------------------------------------------------------------------

//---------------------------------------------------------------------

9. IDENTICAL NAMES OF WINDOWS WITHIN THE SAME PROJECT LEAD TO INTERFACE CONSTRUCTION FAILURES.

//---------------------------------------------------------------------
